#==============================================================================
# 		fichier de D'INSTRUCTIONS de référence
#Julien Brajard
#==============================================================================
#script faisant l'assimilation de référence
#paramètres à régler : TA=50 (48 pdt effectifs)
#NX=32,NY=22,NZ=31
#paramères de contrôle : ta_c
#obs (3D a t=48 Yt=50) : sshb, tb, sb,ub,vb
#

##INITIALISATION
xistate_init 1 ../data_in/file_rest/GYRE_00000800_restart.nc
init_kt 800
true_target_in_tab ta_c
xinitnc ../data_out/exp_T_ebx0.nc

xwriteout 0 true ../data_out/exp_T_ebx0.nc

print_time ON
set_modeltime 0
FORWARD
print_time OFF



##OBSERVATION
xwriteout 120 obs_99 ../data_out/exp_T_ebx0.nc

xrst_save ../data_in/file_rest/GYRE_799_restart_yao_true.nc

xchangesavemode 2 18 14 7

savestate tb 1 ijk 0 A 3 ../data_out/Tb_true_0D.dat


#goto FINRUN



#savestate tb  1   ijk   10%    A       3       ../data_out/tb_0D_obs_100.dat   
savestate tb  1   ijk   120    A       3       ../data_out/tb_0D_obs_120.dat   

loadobs tb  1   ijk   0    A       1     ../data_out/tb_0D_obs_120.dat D   


#goto FINRUN

##INITIALISATION DE L'ASSIMILATION'
xistate_init 1 ../data_in/file_rest/GYRE_00000400_restart.nc
init_kt 800
set_modeltime 0
print_time ON
FORWARD
print_time OFF

xwriteout 0 init ../data_out/exp_T_ebx0.nc
xwriteout 120 forw0_49 ../data_out/exp_T_ebx0.nc
savestate tb 1 ijk 0 A 3 ../data_out/Tb_fg_0D.dat

#EBAUCHE
outoebx ta_c 1 0
set_bcoef ta_c 0.1


#goto FINRUN
##TEST DE LA FONCTION OBJECTIVE
goto FINTEST
testof 1.e+00 0.5e-01 2. 10 1
goto FINRUN
FINTEST
##DEBUT DE L'ASSIMILATION'

set_modeltime 0
!echo "RUN OPTIMIZATION WITH M1QN3 ......."
setm_impres  5
setm_io      6
setm_mode    1
set_nbiter   100
setm_nsim    100
setm_dxmin   1.0e-4
setm_epsg    1.0e-8
setm_ddf1    1
set_qs_parts 1

runm 

#Pour faire sur un nombre limité de pas de temps
#runm 10
#10 : temps absolu

##SAUVEGARDE
xwriteout 0 fin ../data_out/exp_T_ebx0.nc
xwriteout 120 forwfin_99 ../data_out/exp_T_ebx0.nc
savestate tb 1 ijk 0 A 3 ../data_out/Tb_analyse_0D_ebx0.dat
xrst_save ../data_in/file_rest/GYRE_799_restart_yao_ebx0.nc
init_kt 800
set_modeltime 0
xrst_save ../data_in/file_rest/GYRE_800_restart_yao_ebx0.nc



goto FINRUN


FINRUN

