
/***************************************************************************
                 module classe dta_zfimp.h  -  description
***************************************************************************/
// Mohamed Berrada
// locean-ipsl.upmc, Paris, August 1, 2011
//===========================================================================
//                          methode forward
forward (YREAL x1,YREAL x2,YREAL x3)
{ /*	1	from	nu       		1  i 	j    k    
	2	from	dta_zfimp    		1  i 	j    k+1   t
	3	from	dta_zfimp_t    		1  i 	j    k     t */

  if(Yt==1){
    double wm12=1./sqrt(fse3t(Yi,Yj,Yk)); //1/sqrt(dz)
    YS1=wm12*x1;
    if(Yi==0 || Yi==NX-1 || Yj==0 || Yj==NY-1 || Yk==NZ-1){
      YS1=0.;
    }
  }
  else{
    if(Yi==0 || Yi==NX-1 || Yj==0 || Yj==NY-1 || Yk==NZ-1){
      YS1=0.;
    }
    else{
      if(Yk==NZ-2)
	YS1 = x3;
      else
	YS1 = x3 - tab_luzimp( Yi, Yj, Yk+1 , 0 ) * x2;
    }
  }
  //
}
      
//===========================================================================
//                         methode  backward

backward (YREAL x1,YREAL x2,YREAL x3)
{
  YJ1I1=0.;     YJ1I2=0.;     YJ1I3=0.; 
  if(Yt==1){
    double wm12=1./sqrt(fse3t(Yi,Yj,Yk)); //1/sqrt(dz)
    YJ1I1=wm12;
    if(Yi==0 || Yi==NX-1 || Yj==0 || Yj==NY-1 || Yk==NZ-1){
      YJ1I1=0.;
    }
  }
  else{
    if(Yi==0 || Yi==NX-1 || Yj==0 || Yj==NY-1 || Yk==NZ-1){
      YJ1I1=0.;
    }
    else{
      if(Yk==NZ-2)
	YJ1I3 = 1.;
      else{
	YJ1I2 = -tab_luzimp( Yi, Yj, Yk+1 , 0 );
	YJ1I3 = 1.;
      } 
    }
  }
  //
}
