/***************************************************************************
                 module classe rotn.h  -  description
***************************************************************************/
// Mohamed Berrada
// locean-ipsl.upmc, Paris, April 27, 2009
//===========================================================================
//                          methode forward
forward (YREAL x1,YREAL x2,YREAL x3,YREAL x4)
{ /*	1	from	va			1  i+1 	j    k    t
	2	from	va			1  i 	j    k    t
	3	from	ua			1  i	j+1  k    t
	4	from	ua			1  i 	j    k    t*/

  if(Yt==TU){
    YS1=rotn_at_TU(Yi,Yj,Yk);
    //    YS1=0.;
  }
  else{
    if( Yi==NX-1||Yj==NY-1||Yk==NZ-1)
      YS1=0.;
    else
      YS1 = (e2v(Yi+1,Yj)*x1-e2v(Yi,Yj)*x2-e1u(Yi,Yj+1)*x3+e1u(Yi,Yj)*x4)*fmask(Yi,Yj,Yk) / (e1f(Yi,Yj)*e2f(Yi,Yj));
  }
  //
}
//===========================================================================
//                         methode  backward

backward (YREAL x1,YREAL x2,YREAL x3,YREAL x4)
{
  YJ1I1=0.;     YJ1I2=0.;    YJ1I3=0.;    YJ1I4=0.;
  
  if(Yt!=TU){
    if( Yi==NX-1||Yj==NY-1||Yk==NZ-1){
      YJ1I1=0.;     YJ1I2=0.;    YJ1I3=0.;    YJ1I4=0.;
    }
    else{
      YJ1I1=  e2v(Yi+1,Yj  )*fmask(Yi,Yj,Yk)/ (e1f(Yi,Yj)*e2f(Yi,Yj));
      YJ1I2= -e2v(Yi  ,Yj  )*fmask(Yi,Yj,Yk)/ (e1f(Yi,Yj)*e2f(Yi,Yj));
      YJ1I3= -e1u(Yi  ,Yj+1)*fmask(Yi,Yj,Yk)/ (e1f(Yi,Yj)*e2f(Yi,Yj));
      YJ1I4=  e1u(Yi  ,Yj  )*fmask(Yi,Yj,Yk)/ (e1f(Yi,Yj)*e2f(Yi,Yj));
    }
  }
  //
  
}

  //===========================================================================
//*************************  FIN DU MODULE rotn   *************************

