
/***************************************************************************
                 module classe va_dynadv_cen2.h  -  description
***************************************************************************/
// Mohamed Berrada
// locean-ipsl.upmc, Paris, February 27, 2009
//===========================================================================
//                          methode forward
forward (YREAL x1,YREAL x2,YREAL x3)
{/*	x1	from	zfuv_UW_dynadv_cen2	2  i    j    k    t
	x2	from	zfuv_UW_dynadv_cen2	2  i    j    k+1  t
	x3	from	zva_dhmf_dynadv_cen2	1  i    j    k    t*/

  if(Yt==TU)
    YS1=0.;
  else{
    double zva;
    
    if(Yk==NZ-1 || Yj==0 || Yj==NY-1 || Yi==0 || Yi==NX-1)
      YS1=0.;
    else{
      zva=-(x1-x2)/(e1v(Yi,Yj)*e2v(Yi,Yj)*fse3v(Yi,Yj,Yk));
      YS1=zva+x3;
    }
  }
  //  
}

//===========================================================================
//                         methode  backward

backward (YREAL x1,YREAL x2,YREAL x3)
{
  YJ1I1=0.;     YJ1I2=0.;   YJ1I3=0.;  
  if(Yt!=TU){  
    double zva,dzva_x1,dzva_x2;
    
    if(Yk==NZ-1 || Yj==0 || Yj==NY-1 || Yi==0 || Yi==NX-1){
      YJ1I1=0.;     YJ1I2=0.;   YJ1I3=0.;  
    }
    else{
      zva=-(x1-x2)/(e1v(Yi,Yj)*e2v(Yi,Yj)*fse3v(Yi,Yj,Yk));
      dzva_x1=-1./(e1v(Yi,Yj)*e2v(Yi,Yj)*fse3v(Yi,Yj,Yk));
      dzva_x2=-dzva_x1;
      YJ1I1=dzva_x1;
      YJ1I2=dzva_x2;
      YJ1I3=1.;  
    }
  }
  //  
  
 }

  //===========================================================================
//********************* FIN DU MODULE va_dynadv_cen2 **********************
